// Camelotlib version for MIDP;  we've removed functions for floats and 
// file-handling since the necessary classes aren't in the MIDP class hierarchy

import java.io.*;
import java.lang.Exception;

public class Camelotlib {

    private static void error (String s) { 
	System.err.println(s);
	System.exit(0);
    }

    public static void exit (String s) { 
	System.out.println ("Camelot error: " + s); 
	System.exit(0);
    }


    // Null values

    public static boolean isnull (java.lang.Object o) { return (o==null); }

    // Printing

    public static void print_int    (int n)    { System.out.print (n); }
    public static void print_string (String s) { System.out.print (s); }
    public static void print_char   (char c)   { System.out.print (c); }

    public static void print_newline        ()         { System.out.println (); }
    public static void print_int_newline    (int n)    { System.out.println (n); }
    public static void print_string_newline (String s) { System.out.println (s); }
    public static void print_char_newline   (char c)   { System.out.println (c); }



    // Conversions

    public static int int_of_byte  (byte n) { return (int) n; }
    public static byte byte_of_int (int n)  { return (byte) n; }

    public static String string_of_int (int n) { return Integer.toString(n); }

    public static int int_of_string (String s) { 
	try {
	    return Integer.parseInt(s); 
	}
	catch (Exception e) {
	    error ("invalid integer (" + s + ")");
	}
	return 0; // never get here
    }


    public static String string_of_char (char c) { 
	return new Character(c).toString(); 
    }


    // String functions 

    public static int     string_length (String s) { return s.length(); }
    public static String  append_string (String a, String b) { return a+b; }
    public static boolean same_string (String a, String b) { return a.equals(b); }
    public static int     string_compare (String a, String b) { return a.compareTo(b); }
    public static String  nullString () { return null; }

    public static String substring (String s, int start, int len) {
	String t = "";
	try {
	    t = s.substring (start, start+len); 
	}
	catch (IndexOutOfBoundsException e) {
	    error ("index out of bounds in (substring \"" + s + "\" " + start + " " + len + ")");
	}
	return t;
    }

    public static char getc (String s, int j) { 
        char c = 0;
	try {
	    c = s.charAt(j);
	}
	catch (StringIndexOutOfBoundsException e) {
	    error ("index out of bounds in (getc \"" + s + "\" " + j +")");
	}
	return c;
    }

    
    /* Stephen's sleep method for threads */

    public static void sleep(int milliseconds) {
        try {
            java.lang.Thread.currentThread().sleep(milliseconds);
        } catch (InterruptedException e) {
        }
    }
}
