(* Time-stamp: <Mon Mar 28 2005 21:35:06 Stardate: [-29]3704.08 hwloidl> *)
(* $Id: Predicate.sml,v 4.3 2005/07/18 18:44:12 kwxm Exp $ *)
(* Given a list of rich types from the Hofmann-Jost analysis,  generate
   an Isabelle predicate describing them.  Return this as a large string
   which will be passed to Compile.compile and ultimately to ToyGrailNormsyn
   for inclusion in the theory file. *)

(* This is currently incomplete,  but works for simple examples. *)



(* Lennart's example,  for guidance *)
(* DAss {l_,acc_} 0
(emptyfinmap(l_ \<mapsto>\<^sub>f(ListET 1))
(acc_ \<mapsto>\<^sub>f(ListET 0)))
(ListET 0) 0"
*)

open Absyn_ASDL

(* copied from Perv.sml; ToDo: define there and import --  HWL *)
val camelotlib_funs = ["free", "diamond_info", "nullString","print_int","print_float","print_string","print_char","print_newline","print_int_newline","print_float_newline","print_string_newline","print_char_newline","int_of_string","string_of_int","string_of_char","float_of_string","string_of_float","string_length","append_string","same_string","string_compare","substring","getc","open_input","close_input","read_line","read_char","eof","sleep","isnullobj","date"]

(* HWL: HACK: initUC_HACK picks the right flavour of ltac, based on the datatype we find in the functions type  *)
val global_v = ref 0

fun heapFree (RICH_CONty _) = true
  | heapFree _ = false

(* Intertwine list of argument names with arrow type, discarding heap-free args *)

fun mungeArrow (v::vs) (RICH_ARROWty (t1,t2)) =
    if heapFree t1 then (v,t1)::(mungeArrow vs t2)
    else (mungeArrow vs t2)
  | mungeArrow [] (RICH_ARROWty _) = Util.exit "Eek!"
  | mungeArrow [] rt = [("",rt)]  (* return type *)
  | mungeArrow _ _ = Util.exit "NO! NO!"

fun initUC s =
    let val l = String.explode s
    in case l of h::t => implode ((Char.toUpper h)::t)
	       | [] => Util.exit "empty type name in initUC"
    end

fun initUC_HACK tname =
	     if ((((String.size tname)>=4) andalso ((String.substring (tname,0,4)="list") orelse (String.substring (tname,0,4)="List"))) orelse
                 ((String.size tname)>4) andalso ((String.substring (tname,1,4)="list") orelse  (String.substring (tname,1,4)="List")))
		 (* HWL HACK: turn every kind of list into IlistET *)
               then ((* TextIO.print "BONZO detected a list\n" ; *) global_v := 1; "Ilist")
             else
	     if ((((String.size tname)>=4) andalso ((String.substring (tname,0,4)="tree") orelse (String.substring (tname,0,4)="Tree"))) orelse
                 ((String.size tname)>4) andalso ((String.substring (tname,1,4)="tree") orelse  (String.substring (tname,1,4)="Tree")))
		 (* HWL HACK: turn every kind of list into IlistET *)
               then ((* TextIO.print "BONZO detected a tree\n" ; *) global_v := 3; "Itree")
               else initUC tname


val spacesToStr = Util.listToString
	          (fn RICH_CON(name,_,space) => Int.toString space) " "
(*	          (fn RICH_CON(name,_,space) => "[" ^ name ^ "]" ^ Int.toString space) " " *)


fun makeTypeSpec t =
    case t of
	RICH_INTty => "IntET\n"
      | RICH_BOOLty => "BoolET\n"
      | RICH_CHARty => "CharET\n"
      | RICH_BYTEty => "ByteET\n"
      | RICH_SHORTty => "ShortET\n"
      | RICH_LONGty => "LongET\n"
      | RICH_FLOATty => "FloatET\n"
      | RICH_DOUBLEty => "DoubleET\n"
      | RICH_STRINGty => "(" ^ (initUC_HACK "List") ^ "ET 0 0)\n"  (* HWL HACK; should be "stringET\n"*)
      | RICH_UNITty => "UnitET\n"
      | RICH_TVARty s => "'" ^ s
      | RICH_ARRAYty _ => "? arrayET\n"
      | RICH_PRODUCTty _ => "? productET\n"
      | RICH_ARROWty (t1, t2) => makeTypeSpec t1 ^ " -> " ^ makeTypeSpec t2 (* Util.exit "Surprise arrow" *)
      | RICH_CONty (targs, tname, constructors) =>
	let in case constructors of
	    [] => Util.exit "plume"
	  | _ => let
		   val nm = initUC_HACK tname
                   val args = if (nm="Iresult")
                                then spacesToStr (List.take (constructors,1)) ^ " (ItreeET 0 0) " ^ spacesToStr (List.drop (constructors,1))
                                else spacesToStr constructors
                 in
 	           "(" ^ nm ^ "ET " ^ args ^ ")" (* HACK of Iresult -- HWL *)
                 end
(* 	       "(" ^ (initUC_HACK tname) ^ "ET " ^ spacesToStr constructors ^ ")" *) (* HACK of Iresult -- HWL *)
        end
      | RICH_DIAMONDty _ => "<>"
      | RICH_OBJECTty _ => "Object!"
      | RICH_SELFty => "Self?"



fun makeArgSpec basename fname (argname, ty) =
    case ty of
	RICH_CONty (_, tname, constructors) =>
	let in
	    case constructors of
		[] => Util.exit "Multiple plurality mismatch"  (* Clearly this shouldn't occur *)
	      | _ =>
		let
		    val tname' = (initUC_HACK tname) ^ "ET"
		    val p = "(" ^ basename ^ "'" ^ fname ^ "'" ^ argname ^ " \\<mapsto>\\<^sub>f(" ^ tname' ^ " " ^ spacesToStr constructors ^ "))"
		in
		    p
		end
	end
      | _ => Util.exit "Expected datatype in makeArgSpec"

val slash = "\\"
val newline = "\n"

fun makeResultSpec (_, ty) = ") " ^ slash ^ "<ggreater> " ^ (makeTypeSpec ty)



fun makeArrowSpec basename fname [] = ""
  | makeArrowSpec basename fname [(argname,ty)] = makeResultSpec(argname, ty) (* result *)
  | makeArrowSpec basename fname ((argname, ty)::T) =
     (makeArgSpec basename fname (argname, ty))^(makeArrowSpec basename fname T)


fun makeSpec basename fundefs (Absyn_ASDL.RICH_VALDEC(fname, stk_in, ty, stk_out)) =
    let
	fun varName_ (Normsyn.UNITvar _) = "()_"
	  | varName_ (Normsyn.VAR(id, _, _)) = id

	fun getFunArgNames f  =
	    let
		fun find f [] = Util.exit ("can't find function " ^ f)
		  | find f ((Normsyn.FUNdef((name,_),args,_,_,_))::t) =
		    if f = name then map varName_ args
		    else find f t
	    in
		find f fundefs
	    end


	val args = mungeArrow (getFunArgNames fname) ty
	val usedArgs =
	    let
		val t = map #1 args
	    in
		List.take (t, List.length t -1)
	    end


	val pred = (*"\"F_" ^ fname ^ "_Spec == *) slash ^ "<lbrace> {"
		   ^ Util.listToString (fn x => basename ^ "'" ^ fname ^ "'" ^ x) ", " usedArgs
		   ^ ("}, " ^ Int.toString stk_in)
		   ^", (emptyfinmap"
		   ^ makeArrowSpec basename fname args
		   ^ ", "
		   ^ Int.toString stk_out
		   ^ slash ^ "<rbrace>\n"
    in
	(fname,pred)
    end

fun nuke_libfuns l = GrailUtils.list_diff_with
                  (fn (x,y) => case x of
                                  (Absyn_ASDL.RICH_VALDEC(fname, stk_in, ty, stk_out)) => fname=y )
                  l camelotlib_funs

fun makePredicates basename funs l =
 List.foldr (fn (h,z) => let val (name,entry) = makeSpec basename funs h
                         in Binarymap.insert (z, name, entry)
                         end)
            (Binarymap.mkDict (String.compare))
            (nuke_libfuns l)

fun reportTypes basename funs l =
 String.concat
 (List.map (fn Absyn_ASDL.RICH_VALDEC(fname, stk_in, ty, stk_out) => "(*" ^ fname ^ " :: " ^ (global_v := 1; makeTypeSpec ty) ^ "*)\n" ^ "ML {* val global_v_" ^ fname ^ " = " ^ Int.toString (!global_v) ^ " *}\n\n") l)

(*fun makePredicates funs l =
    case l of [] => ""
	    | h::t => (makeSpec funs h) ^ "\n" ^ (makePredicates funs t)*)


(* Old code,  maybe useful

fun makeConSpecs tname args constrs =
    case (args, constrs) of
	(a::args', c::constrs') => (makeArgSpec tname a c) ^ "\n"
      (* Here we're throwing away the Nil constructor,  which is
         fortuitously at the front of the list *)
      | ([], c) => makeResultSpec tname c
      | _ => Util.exit "Length mismatch in makeConSpecs"

fun makeTypeSpec argnames t =
    case t of
	RICH_INTty => "intET\n"
      | RICH_CHARty => "charET\n"
      | RICH_BOOLty => "boolET\n"
      | RICH_FLOATty => "floatET\n"
      | RICH_STRINGty => "stringET\n"
      | RICH_UNITty => "unitET\n"
      | RICH_TVARty s => "'" ^ s
      | RICH_ARRAYty _ => "? arrayET\n"
      | RICH_PRODUCTty _ => "? productET\n"
      | RICH_ARROWty (t1, t2) => Util.exit "Surprise arrow"
      | RICH_CONty (targs, tname, constructors) =>
	makeConSpecs tname argnames constructors
      | RICH_DIAMONDty _ => "<>"
      | RICH_OBJECTty _ => "Object!"
      | RICH_SELFty => "Self?"

*)
