(*
  Machine generated. Edit at your own risk 
  Reproduce with the following
 --pickler=std,sexp
 --lang=sml
 *)
structure Camelot_absyn_ASDL  =
  struct
    
fun myRealfromString s =
    case Real.fromString s of
      NONE => raise Fail "Pickler Error"
      | SOME(r) => r
datatype loc =
          Loc of (StdPrims.int * StdPrims.int)
    
    and ty =
          INTty
        | BOOLty
        | CHARty
        | BYTEty
        | SHORTty
        | LONGty
        | FLOATty
        | DOUBLEty
        | STRINGty
        | UNITty
        | TVARty of (tVarNm)
        | ARRAYty of (ty)
        | PRODUCTty of (ty list)
        | ARROWty of (ty * ty)
        | CONty of (ty list * StdPrims.string)
        | DIAMONDty of (StdPrims.string)
        | OBJECTty of (StdPrims.string)
    
    and heapUsage =
          HEAP
        | NOHEAP
    
    and typeCon =
          TYPEcon of (varNm * ty list * heapUsage)
    
    and typeDec =
          TYPEdec of (tVarNmL list * varNm * typeConL list)
    
    and funAssns =
          FUNASSNS of (varNm * assn list * assn list)
    
    and hints =
          HINTS of (typeDecL list * funAssns list)
    
    and rich_constructor =
          RICH_CON of (StdPrims.string * rich_ty list * StdPrims.int)
    
    and rich_ty =
          RICH_INTty
        | RICH_BOOLty
        | RICH_CHARty
        | RICH_BYTEty
        | RICH_SHORTty
        | RICH_LONGty
        | RICH_FLOATty
        | RICH_DOUBLEty
        | RICH_STRINGty
        | RICH_UNITty
        | RICH_TVARty of (tVarNm)
        | RICH_ARRAYty of (rich_ty)
        | RICH_PRODUCTty of (rich_ty list)
        | RICH_ARROWty of (rich_ty * rich_ty)
        | RICH_CONty of (rich_ty list * varNm * rich_constructor list)
        | RICH_DIAMONDty of (StdPrims.string)
        | RICH_OBJECTty of (StdPrims.string)
        | RICH_SELFty
    
    and rich_valdec =
          RICH_VALDEC of (StdPrims.string *
            StdPrims.int *
            rich_ty *
            StdPrims.int)
    
    and external =
          GLOBAL
        | LOCAL
        | BUILTIN
        | EXTERN
    
    and boolX =
          TRUEval
        | FALSEval
    
    and value =
          VARval of (varNm * external)
        | CHARval of (StdPrims.int)
        | INTval of (StdPrims.int)
        | FLOATval of (real)
        | STRINGval of (StdPrims.string)
        | BOOLval of (boolX)
        | UNITval
        | NULLval
    
    and unaryOperator =
          NOTop
        | ISNULLop
    
    and binaryOperator =
          PLUSop
        | MINUSop
        | TIMESop
        | DIVop
        | MODop
        | LANDop
        | LORop
        | LXORop
        | LSLop
        | LSRop
        | ASRop
        | FPLUSop
        | FMINUSop
        | FTIMESop
        | FDIVop
        | LESSop
        | LEQop
        | EQUALSop
        | CONCATop
    
    and matchDiam =
          NOWHERE
        | SOMEWHERE of (varNmL)
        | DISPOSE
    
    and ooMatchPat =
          CLASSpat of (varNm * varNm)
        | ANYCLASSpat
    
    and instance =
          INSTANCE
        | STATIC
    
    and valDec =
          VALdec of (varNm * ty * instance)
    
    and fieldDec =
          FIELDdec of (varNm * ty * instance)
    
    and classDec =
          CLASSdec of (varNm * varNm option * varNm list * valDec list)
    
    and varTy =
          UNITvar
        | VAR of (StdPrims.string * ty option)
    
    and test =
          TEST of (binaryOperator * value * value)
    
    and oomatchRule =
          OOMATCHrule of (ooMatchPat * expL)
    
    and matchRule =
          MATCHrule of (varNmL * varNmL list * matchDiam * expL)
    
    and exp =
          VALexp of (value)
        | UNARYexp of (unaryOperator * value)
        | BINexp of (binaryOperator * value * value)
        | APPexp of (varNm * value list * external)
        | CONexp of (varNm * value list * varNmL option)
        | INVOKEexp of (varNm * StdPrims.string * value list)
        | NEWexp of (varNm * value list)
        | GETexp of (varNm * varNm)
        | SGETexp of (varNm)
        | UPDATEexp of (varNm * value)
        | SUPERMAKERexp of (value list)
        | COERCEexp of (varNm * ty)
        | LETexp of (varNm * expL * expL)
        | IFexp of (test * expL * expL)
        | MATCHexp of (varNm * matchRuleL list)
        | OOMATCHexp of (varNm * oomatchRuleL list)
        | TYPEDexp of (expL * ty)
        | ASSERTexp of (expL * assn list * assn list)
    
    and funDef =
          FUNdef of (varNm * varTyL list * instance * expL)
    
    and classDef =
          CLASSdef of (varNm *
            varNm option *
            varNm list *
            fieldDecL list *
            funDefL list)
    
    and funBlock =
          FUNblock of (funDefL list)
    
    and program =
          PROG of (typeDecL list *
            classDecL list *
            classDefL list *
            valDecL list *
            funBlock list)
    
    withtype float = (StdPrims.string)
    and assn = (Assertions_ASDL.assn)
    and varNm = (StdPrims.string)
    and tVarNmL = (Location.Location * StdPrims.string)
    and tVarNm = (StdPrims.string)
    and typeConL = (Location.Location * typeCon)
    and typeDecL = (Location.Location * typeDec)
    and varNmL = (Location.Location * StdPrims.string)
    and oomatchRuleL = (Location.Location * oomatchRule)
    and matchRuleL = (Location.Location * matchRule)
    and expL = (Location.Location * exp)
    and varTyL = (Location.Location * varTy)
    and fieldDecL = (Location.Location * fieldDec)
    and funDefL = (Location.Location * funDef)
    and classDecL = (Location.Location * classDec)
    and classDefL = (Location.Location * classDef)
    and valDecL = (Location.Location * valDec)
    and valueL = (Location.Location * value)
    and name = (StdPrims.string)
    
  end (* struct *)

